//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2011-2011 - DIGITEO - Bruno JOFRET
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//
//

function [x,y,typ]=REP_FREQ(job,arg1,arg2)
  x=[];y=[];typ=[];
  select job
   case 'plot' then
// deprecated
   case 'getinputs' then
// deprecater
   case 'getoutputs' then
// deprecated
   case 'getorigin' then
// deprecated
   case 'set' then
    x=arg1;
    graphics=arg1.graphics;
    exprs=graphics.exprs
    model=arg1.model;
    
    
 
 while %t do
      [ok,diag_type, exprs]=scicos_getvalue('Choose diagram type (1 for Bode, 2 for Black, 3 for Nyquist)',..
                                                ['Diagram type'], ..
                                                list("vec",1),[string(model.ipar)])
          mess=[];

          if ~ok then
// Cancel
              break;
          end
          if diag_type <> 1 & diag_type <> 2 & diag_type <> 3
              mess=[mess ;_("Diagram type must be 1, 2 or 3")]
              ok = %f
          end
          
         if ok then
// Everything's ok
              model.ipar=diag_type
          select diag_type
              case 1 then
              Nom="Bode"
              case 2 then
              Nom="Black"
              case 3 then 
              Nom="Nyquist"
          end
              graphics.exprs=Nom;
              x.model=model;
              x.graphics=graphics;
              break;
          else
              message(mess);
          end

  end
 
    while %t do
      [ok2,inputsignal,outputsignal, exprs]=scicos_getvalue('Set BODE Input/Output signals',..
                                                ['Input signal';'Output signal'], ..
                                                list("str",-1, "str", -1),model.opar)
          mess=[];

          if ~ok2 then
// Cancel
              break;
          end

          
         if ok2 then
// Everything's ok
   
              model.opar=list(inputsignal,outputsignal)
              x.model=model;
              break
          else
              message(mess);
          end

  end

// recupération des fréquences

while %t do
    mess=[]
    if exists("model.rpar(3)") then num_wi=string(model.rpar(3));
        else num_wi="";
    end
      [ok3,wmin,wmax,num_w exprs]=scicos_getvalue('Frequency bounds',..
                                                ['wmin (rad/s)';'wmax (rad/s)';'Number of points (optional)'], ..
                                                list("vec",1, "vec", 1,"vec",-1),[string(model.rpar(1));string(model.rpar(2));num_wi])
          mess=[];

          if ~ok3 then
// Cancel
              break;
          end
        if wmin<>int(wmin) | wmax<>int(wmax) | (~isempty(num_w) & num_w<>int(num_w))
              mess=[mess ;_("Pulsations and number of points must be integers")]
              ok = %f
          end
          
          if wmin<0 | wmax<0 | (~isempty(num_w) & num_w<0)
              mess=[mess ;_("Pulsations and number of points must be integers")]
              ok = %f
          end
          
          if wmin>wmax
              mess=[mess ;_("wmax must be greater than wmin")]
              ok = %f
          end
          
         if ok3 then
// Everything's ok
   
              model.opar=list(inputsignal,outputsignal) 
              model.rpar=[wmin,wmax,num_w]
              x.model=model;
              break
          else
              message(mess);
          end

  end


     case 'define' then
      model=scicos_model();
        k=1;
        model.sim=list("REP_FREQ_sim",99) // 99 type blocks are ignored by simulator.
        model.blocktype='c';
        model.dep_ut=[%f %f];
        model.in=[];
        model.intyp=[];
        model.out=[];
        model.outtyp=[];
        model.rpar=[1e-3,1e3];
        model.ipar=[1];
        model.opar=list("signal1","signal2")
        x=standard_define([2 2],model,[],[]);
        x.graphics.in_implicit=[];
        x.graphics.out_implicit=[];
        x.graphics.style=["blockWithLabel;verticalLabelPosition=center;displayedLabel= %s"]
        x.graphics.exprs="Bode";
        
    end

endfunction
